<?php
require_once('wp-load.php');

$user = wp_get_current_user();
if (!in_array("administrator",$user->roles))
	exit("not an admin");

error_reporting(E_ALL&~E_NOTICE); ini_set('display_errors', 1); 
ini_set('output_buffering', 'off');
ini_set('implicit_flush', true);
ob_implicit_flush(true);
ob_flush();
flush();




$posts=get_posts(array('post_type'=>'post', 'post_status'=>'publish', 'posts_per_page'=>-1));

set_time_limit(300);

if (file_exists("articles.txt"))
	$content=json_decode(file_get_contents("articles.txt"));
else
{
	$content=array();
	foreach($posts as $post)
	{
		$uri=get_permalink($post->ID);
		$html=file_get_contents($uri);
		$doc = new \DOMDocument();
		$doc->loadHTML($html);

		$xpath = new DomXPath($doc);
		$elms = $xpath->evaluate("//*[contains(@class, 'entry-content')]");
		$text="";
		foreach($elms as $elm)
			$text.=$elm->textContent;	
		$content[$post->ID]=$text;
	}
	file_put_contents("articles.txt",json_encode($content));
}

$lexique=file("lexique.txt",FILE_IGNORE_NEW_LINES);

foreach($lexique as $k=>$word)
{
	//suppression des accents et majuscules
	$lexique[$k]=noaccent(strtolower($word));
	
	//séparation des mots composés
	$words=preg_split('#\b#',$word);
	$lexique[$k]=$words[0];
	for($i=1;$i<count($words);$i++)
		$lexique[]=$words[$i];
}

foreach($content as $id=>$text)
{
	$text=html_entity_decode($text);
	$text=strtolower($text);

	$words=preg_split('#\b#imsu',$text);

	$wordcount=array();
	foreach($words as $word)
	{
		print ".";
		$simpleword=noaccent(strtolower($word));
		
		if (strlen($word)>2 && !in_array($simpleword,$lexique) && !is_numeric($word) && preg_match('#[a-z]+#i',$word))
			$wordcount[$word]++;
	}
	$lasttags=array();
	for($rep=1;$rep<10;$rep++)
	{
		$tags=array();
		foreach($wordcount as $word=>$count)
		{
			if ($count>$rep)
				$tags[]=$word;
		}
		print "<br>$rep rep : ".count($tags);
		if (count($tags)<20)		//pas plus de 20 tags
			break;
		$lasttags=$tags;
	}
	if (count($tags)<10 && count($lasttags)>count($tags))
		$tags=$lasttags;
	
	print "<pre>";
	print_r($tags);
	print "</pre>";
	wp_set_post_tags( $id, $tags, false);
}


function noaccent($str)
{
	$str = htmlentities($str, ENT_NOQUOTES, 'utf-8');
	$str = preg_replace('#&([A-za-z])(?:uml|circ|tilde|acute|grave|cedil|ring);#', '\1', $str);
	$str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str);
	$str = preg_replace('#&[^;]+;#', '', $str);
	
	return $str;
}
